#include <bits/stdc++.h>

using namespace std;

int a[2*10^6+5];
int main()
{
    int n,k;
    cin>>n>>k;
    for(int i=0;i<2*n+5;i++){
        a[i]=0;
    }
    for(int i=0;i<n;i++){
        int x;
        cin>>x;
        if(x<0){
            x=n+abs(x);
        }
        a[x]++;
    }
    int res=0;
    for(int i=0;i<=2*n+3;i++){
        if(a[i]>=k){
            res++;
        }
    }
    cout<<res<<endl;
    for(int i=0;i<=n;i++){
        if(a[i]>=k){
            cout<<i<<" ";
        }
    }
    for(int i=n+1;i<=2*n+3;i++){
        if(a[i]>=k){
            cout<<n-i<<" ";
        }
    }
    return 0;
}